'\"
'\" Generated from file '/net/nas/data/andreask/Dev/Kettle/kettle/embedded/man/files/kettle_devguide.n' by tcllib/doctools with format 'nroff'
'\"
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" RCS: @(#) $Id: man.macros,v 1.1 2009/01/30 04:56:47 andreas_kupries Exp $
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH "kettle_devguide" n 1 doc "Kettle - The Quick Brew System"
.BS
.SH NAME
kettle_devguide \- Kettle - The Developer's Guide
.SH SYNOPSIS
package require \fBTcl  8.5\fR
.sp
.BE
.SH DESCRIPTION
.PP
Welcome to Kettle, a set of packages providing support for writing
build code for Tcl packages.
.PP
Please read the document \fIKettle - Introduction to Kettle\fR,
if you have not done so already, to get an overview of the whole system.
.PP
This document is a guide for developers working on Kettle,
i.e. maintainers fixing bugs, extending the functionality of
application or package, etc.
.PP
Users of kettle wishing to write their own high-level commands
linking into the existing foundations should read the
\fIKettle - Core\fR document instead, as that is the reference
manpage to the whole functionality available to them, and likely
enough to get going.
.PP
Please read
.IP [1]
\fIKettle - License\fR,
.IP [2]
\fIKettle - How To Get The Sources\fR, and
.IP [3]
\fIKettle - The Installer's Guide\fR
.PP
first, if that was not done already.
.PP
Here we assume that the sources are already available in a directory
of your choice, and that you not only know how to build and install
them, but also have all the necessary requisites to actually do
so. The guide to the sources in particular also explains which source
code management system is used, where to find it, how to set it up,
etc.
.SH "DEVELOPING FOR KETTLE"
.SS ARCHITECTURE
The high-level architecture is shown in the image below:
.PP
.PS
.nf
+-------------------------------------------------------------------------------+
| build.tcl                                                                     |
+-------------------------------------------------------------------------------+
+-------------------------------------------------------------------------------+
| kettle                                                                        |
|        +----------------------------------------------------------------------+
|        | +-------------+ +----------------+ +-------------+ +-----------------+
|        | | kettle::tcl | | kettle::tclapp | | kettle::doc | | kettle::figures |
+--------+ +-------------+ +----------------+ +-------------+ +-----------------+
+-------------------------------------------------------------------------------+
| kettle, kettle::util                                                          |
+-------------------------------------------------------------------------------+

.fi
.PE
.PP
This document is concerned with the lowest level shown, the core
kettle package itself. The inner boxes of that architectural box show
the parts which are user-visible, i.e. providing the DSL commands
explained in \fIKettle - Build Declarations\fR.
For the details we have
.PP
.PS
.nf

*critcl    <- doc, testsuite, recipes, tool, options, path, io, try
*tcl       <- doc, testsuite, recipes, path, try

standard  <- recipes, options, gui, strutil
*doc       <- figures, recipes, tool, options, path, io

*testsuite <- recipes, invoke, options, path, status, (io), strutil, try
*figures   <- recipes, tool, path, io
*tclapp    <- recipes, path, io
app       <- recipes, options, path, status, (io), try
gui       <- options, (ovalidate), recipes, status, (io)

*depend    <- options
tool      <- options, io
invoke    <- options, path, status, (io), try
recipes   <- status, (io), strutil, try, lambda

options   <- path, status, ovalidate, (io), strutil, lambda
ovalidate <- /option/, path, lambda
path      <- /option/, status, (io), try
status    <- /option/, /path/, io

io
strutil
try
lambda

.fi
.PE
.PP
In this image we now see all the components found inside of the kettle
package, their organization into layers and their dependencies. The
latter is actually a bit simplified, showing only the dependencies
between adjacent layers and leaving out the dependencies crossing
layers. Adding them would make the image quite a bit more crowded.
.PP
The green boxes are again the user-visible parts, either for
the build declarations. The rest is internal. Note how and that the
components found in the blue box are all dependent on each other,
i.e. these are in circular dependencies.
.PP
The names in the boxes directly refer to the file names
containing the code of the component, without the extension,
"\fI.tcl\fR".
The only file not mentioned is "\fIkettle.tcl\fR" which is the
entrypoint to the package and sources all the others.
.PP
More information about the functionality made available by each
component is found in \fIKettle - Core\fR, the reference to all
commands.
.SS "DIRECTORY STRUCTURE"
.TP
Helpers
.TP
Documentation
.RS
.TP
"\fIdoc/\fR"
This directory contains the documentation sources. The texts are written
in \fIdoctools\fR format, whereas the figures are a mixture of TeX (math
formulas), and tklib's \fBdia\fR(gram) package and application.
.TP
"\fIembedded/\fR"
This directory contains the documentation converted to regular manpages
(nroff) and HTML.
It is called embedded because these files, while derived, are part of the
fossil repository, i.e. embedded into it. This enables fossil to access
and display these files when serving the repositories' web interface.
The "Command Reference" link at
\fIhttp://chiselapp.com/user/andreas_kupries/repository/Kettle/home\fR
is, for example, accessing the generated HTML.
.RE
.TP
Package Code, General structure
See the second image in section \fBArchitecture\fR, and the
associated explanations.
.PP
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems.
Please report such at the
\fIKettle Tracker\fR [https://chiselapp.com/user/andreas_kupries/repository/Kettle/index].
Please also report any ideas for enhancements you may have for either
package and/or documentation.
.SH KEYWORDS
build tea
.SH CATEGORY
Build support